## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005
##
## JUnitCapture by Jeckel.
##

from CvPythonExtensions import *

import Popup as PyPopup
import CvUtil
import CvEventManager
import sys

import CvConfigParser
import CvPath

import CvJUnitCaptureGameUtils


# globals
gc = CyGlobalContext()

uc = CvJUnitCaptureGameUtils.JUnitCapture()

config = CvConfigParser.CvConfigParser("JUnitCapture Mod Config.ini")



# Change the value to enable or disable the features from the JUnitReligion Mod.
# Default value is true
g_bJUnitCaptureFeaturesEnabled = True

def loadConfigurationData():

	global g_bJUnitCaptureFeaturesEnabled

	config = CvConfigParser.CvConfigParser("JUnitCapture Mod Config.ini")

	if(config != None):

		g_bJUnitCaptureFeaturesEnabled = config.getboolean("JUnitCapture Mod", "JUnitCapture Features Enabled", True)
		
###################################################


class CvJUnitCaptureEventManager:
	def __init__(self, eventManager):

		# initialize base class

		loadConfigurationData()

		if(g_bJUnitCaptureFeaturesEnabled):
                        eventManager.addEventHandler("combatResult", self.onCombatResult)
                        #eventManager.addEventHandler("unitMove", self.onUnitMove)


        def onCombatResult(self, argsList):
		'Combat Result'
		pWinner, pLoser = argsList

		loadConfigurationData()

		if(g_bJUnitCaptureFeaturesEnabled):
			uc.onCombatResult(argsList)


	def onUnitMove(self, argsList):
		'unit move'
		pPlot, pUnit = argsList

		loadConfigurationData()

		if(g_bJUnitCaptureFeaturesEnabled):
			uc.onUnitMove(argsList)













